from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class LocalList(ListResource):
    def __init__(self, version: Any, account_sid: Any) -> None: ...
    def stream(self, beta: Any = ..., friendly_name: Any = ..., phone_number: Any = ..., origin: Any = ..., limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, beta: Any = ..., friendly_name: Any = ..., phone_number: Any = ..., origin: Any = ..., limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, beta: Any = ..., friendly_name: Any = ..., phone_number: Any = ..., origin: Any = ..., page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def create(self, phone_number: Any, api_version: Any = ..., friendly_name: Any = ..., sms_application_sid: Any = ..., sms_fallback_method: Any = ..., sms_fallback_url: Any = ..., sms_method: Any = ..., sms_url: Any = ..., status_callback: Any = ..., status_callback_method: Any = ..., voice_application_sid: Any = ..., voice_caller_id_lookup: Any = ..., voice_fallback_method: Any = ..., voice_fallback_url: Any = ..., voice_method: Any = ..., voice_url: Any = ..., identity_sid: Any = ..., address_sid: Any = ..., emergency_status: Any = ..., emergency_address_sid: Any = ..., trunk_sid: Any = ..., voice_receive_mode: Any = ..., bundle_sid: Any = ...): ...

class LocalPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class LocalInstance(InstanceResource):
    class AddressRequirement:
        NONE: str = ...
        ANY: str = ...
        LOCAL: str = ...
        FOREIGN: str = ...
    class EmergencyStatus:
        ACTIVE: str = ...
        INACTIVE: str = ...
    class VoiceReceiveMode:
        VOICE: str = ...
        FAX: str = ...
    def __init__(self, version: Any, payload: Any, account_sid: Any) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def address_sid(self): ...
    @property
    def address_requirements(self): ...
    @property
    def api_version(self): ...
    @property
    def beta(self): ...
    @property
    def capabilities(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def friendly_name(self): ...
    @property
    def identity_sid(self): ...
    @property
    def phone_number(self): ...
    @property
    def origin(self): ...
    @property
    def sid(self): ...
    @property
    def sms_application_sid(self): ...
    @property
    def sms_fallback_method(self): ...
    @property
    def sms_fallback_url(self): ...
    @property
    def sms_method(self): ...
    @property
    def sms_url(self): ...
    @property
    def status_callback(self): ...
    @property
    def status_callback_method(self): ...
    @property
    def trunk_sid(self): ...
    @property
    def uri(self): ...
    @property
    def voice_receive_mode(self): ...
    @property
    def voice_application_sid(self): ...
    @property
    def voice_caller_id_lookup(self): ...
    @property
    def voice_fallback_method(self): ...
    @property
    def voice_fallback_url(self): ...
    @property
    def voice_method(self): ...
    @property
    def voice_url(self): ...
    @property
    def emergency_status(self): ...
    @property
    def emergency_address_sid(self): ...
    @property
    def bundle_sid(self): ...
    @property
    def status(self): ...
