from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.studio.v1.flow.engagement.engagement_context import EngagementContextList as EngagementContextList
from twilio.rest.studio.v1.flow.engagement.step import StepList as StepList
from typing import Any, Optional

class EngagementList(ListResource):
    def __init__(self, version: Any, flow_sid: Any) -> None: ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def create(self, to: Any, from_: Any, parameters: Any = ...): ...
    def get(self, sid: Any): ...
    def __call__(self, sid: Any): ...

class EngagementPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class EngagementContext(InstanceContext):
    def __init__(self, version: Any, flow_sid: Any, sid: Any) -> None: ...
    def fetch(self): ...
    def delete(self): ...
    @property
    def steps(self): ...
    @property
    def engagement_context(self): ...

class EngagementInstance(InstanceResource):
    class Status:
        ACTIVE: str = ...
        ENDED: str = ...
    def __init__(self, version: Any, payload: Any, flow_sid: Any, sid: Optional[Any] = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def flow_sid(self): ...
    @property
    def contact_sid(self): ...
    @property
    def contact_channel_address(self): ...
    @property
    def context(self): ...
    @property
    def status(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def delete(self): ...
    @property
    def steps(self): ...
    @property
    def engagement_context(self): ...
