from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class OriginationUrlList(ListResource):
    def __init__(self, version: Any, trunk_sid: Any) -> None: ...
    def create(self, weight: Any, priority: Any, enabled: Any, friendly_name: Any, sip_url: Any): ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def get(self, sid: Any): ...
    def __call__(self, sid: Any): ...

class OriginationUrlPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class OriginationUrlContext(InstanceContext):
    def __init__(self, version: Any, trunk_sid: Any, sid: Any) -> None: ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, weight: Any = ..., priority: Any = ..., enabled: Any = ..., friendly_name: Any = ..., sip_url: Any = ...): ...

class OriginationUrlInstance(InstanceResource):
    def __init__(self, version: Any, payload: Any, trunk_sid: Any, sid: Optional[Any] = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def sid(self): ...
    @property
    def trunk_sid(self): ...
    @property
    def weight(self): ...
    @property
    def enabled(self): ...
    @property
    def sip_url(self): ...
    @property
    def friendly_name(self): ...
    @property
    def priority(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, weight: Any = ..., priority: Any = ..., enabled: Any = ..., friendly_name: Any = ..., sip_url: Any = ...): ...
